

// rev 02-01-2021   Oled init !! for 20x10mm mini-OLED display



#include <stdint.h>
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
#include "Fontes_for_OLED.h"
#include "OLED_SSD1306_I2C_Hardw_18Fx7K42_2021.h"

#ifndef _XTAL_FREQ 
#define _XTAL_FREQ 64000000  
#define FOSC      64000000              // Fosc=64MHz
#define FCY       (FOSC/4)              // Fcy=16MHz
#endif



unsigned char Addr;
static  unsigned char data_I2C[8];

void OLED_Cde( unsigned char command )
{
 data_I2C[0]=SSD1306_COMMAND;
 data_I2C[1]=command;
 I2C1_WriteNBytes(SSD1306_ADDR, data_I2C, 2);  
 }

void OLED_Donnee(unsigned char value )
{ 
  Addr=SSD1306_ADDR;
  data_I2C[0] =SSD1306_DATA  ; 
  data_I2C[1] =value; 
  I2C1_WriteNBytes(SSD1306_ADDR, data_I2C, 2);
     
}


void OLED_SetPos(unsigned char x, unsigned char y)
{ 
       OLED_Cde(0xB0+y);
       OLED_Cde(x&0x0f) ;
       OLED_Cde(((x&0xf0)>>4)|0x10);
       __delay_ms(20);
       
}

/*
 
void SSD1306_SetFont( const uint8_t *font)
{
  sfont.font = font;
  sfont.x_size = *(font+0);
  sfont.y_size = *(font+1);
  sfont.offset  = *(font+2);
  sfont.numchars  = *(font+3);
  sfont.inverted = false;
}
 * */


void Write_Char_At(unsigned char X,unsigned char Y, unsigned char C)
{ int i;
unsigned char ca;
     OLED_SetPos(X,Y);
     if (C==176)     // caractere  (degrC)  dplac en codage 124 (124-32=92)
      {
      for(i=0;i<6;i++)   OLED_Donnee(Fonte_6x8[92][i]) ;
      }
      else
      {
        if (C>=32)
        {
         ca=C-32;
         for(i=0;i<6;i++)  OLED_Donnee(Fonte_6x8[ca][i]) ;
       }
     }
}



void OLED_WriteString(unsigned char *ch)
{
  while (*ch) OLED_WriteCharacter(*(ch++));
}

void OLED_WriteCharacter(unsigned  char ch)
{ int i,k;
  
  k=(ch - 0x20)*5 ;
  for (i=0; i<5; i++) OLED_Donnee(Fonte_5x7[k+i]);
  OLED_Donnee(0x00);    // ==> 6x8    128/6=> 21 car/ligne
 // OLED_Donnee(0x00);  // ==> 7x8    128/7=> 18 car/ligne
 // OLED_Donnee(0x00);  // ==> 8x8    128/6=> 16 car/ligne
}

void OLED_SetContrast( unsigned char contrast )
{
  OLED_Cde(SSD1306_SET_CONTRAST_CONTROL );
  OLED_Cde(contrast);
}

//function to clear OLED by writing to it.
void OLED_Clear(void)
{
  // rev 02-01-2021
    //int i =0;
    // OLED 128* 32 pixels = total pixels -> (4096 / 1 byte) = 512 passes.
    // SSD1306_CLEAR_SIZE  = 512 for 128* 32 or 1024  for 128*64
    //for (i=0; i<SSD1306_CLEAR_SIZE ; i++) 
    //{
    //  OLED_Donnee(0x00); // clear oled screen
    //  __delay_us(10);
    //}
  OLED_ClearLine(3);
  OLED_ClearLine(2);
  OLED_ClearLine(1);
  OLED_ClearLine(0);
 // OLED_SetPos(0,0);
  
  
  
}

//function to clear OLED  line passed page number
void OLED_ClearLine(unsigned char page_num)
{
    OLED_SelectPage(page_num);
    int i =0;
  // Clear line of 128 pixels of current page
    for (i=0; i<128 ; i++) 
    {
      OLED_Donnee(0x00); // clear oled screen 
      __delay_us(10);
    }
}

// Function to select [page] i.e. row or line number
// 128*32 has page 0-3
// 128* 64 has page 0-7
// Passed page num / byte
// page 0   8 
// page 1   16
// page 2   24
// page 3   32
//============
// page 4   40
// page 5   48
// page 6   56
// page 7   64

void OLED_SelectPage(unsigned char page_num)
{
 unsigned char Result =0xB0 | page_num; // Mask or with zero lets everything thru
 OLED_Cde(Result); 
 OLED_Cde(SSD1306_SET_LOWER_COLUMN);
 OLED_Cde(SSD1306_SET_HIGHER_COLUMN); 
}


//--------------------------------------------------------------
// Prototype      : void OLED_ShowChar(unsigned char x, unsigned char y, unsigned char ch[], unsigned char TextSize)
// Parameters     : x,y --(x:0~127, y:0~7); ch[] ; TextSize (1:6*8 ; 2:8*16)
//--------------------------------------------------------------
void OLED_ShowStr(unsigned char x, unsigned char y, unsigned char *ch, unsigned char TextSize)
{
        unsigned char c = 0,i = 0,j = 0;
        unsigned char xd=0,yd=0;
        int kx,lx;
        xd=x;
        yd=y;
        OLED_SetPos(xd,yd);
        switch(TextSize)
        {
                case 1:
                    while((*(ch+j) !=0) && ( yd<5))
                    {
                     c =(*(ch+j) - 32)*5;
                     if(xd > 120)
                     {
                      xd = x;
                      yd++;
                       OLED_SetPos(xd,yd);
                     }
                      for(i=0;i<5;i++)   OLED_Donnee(Fonte_5x7[c+i]) ;
                      OLED_Donnee(0x00);
                     xd=xd+5;
                     j++;
                    }
                    break;
                case 2:
                    while((*(ch+j) !=0) && ( yd<5))
                    {
                     c = *(ch+j) - 32;
                     if(xd > 120)
                     {
                      xd = x;
                      yd++;
                       OLED_SetPos(xd,yd);
                     }
                      for(i=0;i<6;i++)   OLED_Donnee(Fonte_6x8[c][i]) ;
                     xd=xd+6;
                     j++;
                    }
                    break;
                case 3:
                     kx=sizeof(ch);//strlen(ch);
                     j=0;
                     while((*(ch+j) !=0) && (j<15) )
                     {
                      c = *(ch+j) - 32;
                      //if(xd > 112)        // width > 14 chars x8
                      //{
                      //  xd = x;      // si deborde la ligne
                      //  yd=yd+1;     // change de ligne
                      //  }
                      OLED_SetPos(xd,yd);
                      for(i=0;i<8;i++) OLED_Donnee(F8X16[c*16+i]);
                     OLED_SetPos(xd,yd+1);
                     for(i=0;i<8;i++) OLED_Donnee(F8X16[c*16+i+8]);
                      xd=xd+8;
                      j++;
                     }
                      break;
               // case 4:
                       // voir  Big_affichage(kx,c-48);
                       // break;    
              default:
                    break  ;
        }
}


void OLED_DrawBMP(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,const unsigned char *BM)
{
        unsigned int j=0;
        unsigned char x,y;
        unsigned char C1;
     //   CRLF1();
     //   UART1_Write_CText("BitMap \r\n");
 // OLED_OFF() ;
  if((y1%NBPAGES)==0)
        y = y1/NBPAGES;
      else
     y = y1/NBPAGES + 1;

   /*
       if((y1%4)==0)
        y = y1/4;
      else
     y = y1/4 + 1;
     */
     for(y=y0;y<y1;y++)
     {
       OLED_SetPos(x0,y);
      for(x=x0;x<x1;x++)
      {
      C1=BM[j++];
       OLED_Donnee(C1);
    //   Decompile_byte(C1);
     }
   //  CRLF1();
     }
   //   OLED_ON();
}



void OLED_Init(void)
{
//SSD1306.pdf
//Software Configuration   31/12/2020   OK avec mini_OLED 20x10mm

       OLED_Cde(0xAE); //display off
      __delay_ms(200);
       OLED_Cde(0xAF); //display on
       __delay_ms(100);
       OLED_Cde(0xB0);// Set GDDRAM Page start adresse [2:0]  0  7
       OLED_Cde(0x00);   // mini 0
       OLED_Cde(0x03);   // maxi
       //  OLED_Cde(0x07);   // maxi  pour 128x64
       OLED_Cde(0x20); //Set Horizontal Memory Addressing Mode
                       //A[1:0] = 00b, Horizontal Addressing Mode
                       //A[1:0] = 01b, Vertical Addressing Mode
                       //A[1:0] = 10b, Page Addressing Mode (RESET)
                       //A[1:0] = 11b, Invalid
        OLED_Cde(0x02); //    Page Addressing Mode (RESET)
        OLED_Cde(0x21); // Setup column start and end address
        OLED_Cde(0);   //A[6:0] : Column start address, range : 0-127d,(RESET=0d)
        OLED_Cde(0x7F);  // B[6:0]: Column end address, range : 0-127d,(RESET =127d)
        OLED_Cde(0x22);//  Setup page start and end address
                         //  A[2:0] : Page start Address, range : 0-7d,
                         // (RESET = 0d)
                         //  B[2:0] : Page end Address, range : 0-7d,
                         // (RESET = 7d)
        OLED_Cde(0x00);
        OLED_Cde(0x03);     //was 0x07
       // OLED_Cde(0xA0); //--set segment re-map colum 0 to SEG 0     de droite -> gauche
       OLED_Cde(0xA1); //--set segment re-map to 127     de gauche -> droite
       OLED_Cde(0xA4);//command enable display outputs according to the GDDRAM contents.
       //  OLED_Cde(0xA5);//command forces the entire display to be ?ON?, regardless of the contents of the display data RAM.
       OLED_Cde(0xA6);//normal display
       //  OLED_Cde(0xA7);//reverse display
       OLED_Cde(0xC8); //Set COM Output Scan Direction
       //C0h, X[3]=0b: normal mode (RESET) Scan from COM0 to COM[N ?1]
       //C8h, X[3]=1b: remapped mode. Scan from COM[N-1] to COM0
       OLED_Cde(0xD3); //--set start line address 40h =  set   to 0
       OLED_Cde(0x00);  //was 0x3F
      // OLED_Cde(0x3F);
       // was     OLED_Cde(0x00);
       //0xD3,0x3F, // DISPLAY offset ROW0 - L0xD3,0x00,leaves one row of pixels at top. 0xD3,0x3F is better
       OLED_Cde(0xD5); //--set display clock divide ratio/oscillator frequency
       OLED_Cde(0x80); //--set divide ratio   80h
       OLED_Cde(0xA8); //--set multiplex ratio to 63
       OLED_Cde(0x3F); //  was 3F
       OLED_Cde(0xD6); //-- This command is to set the vcommon signals padconfiguration.
       OLED_Cde(0x80); // --set divide ratio   80h
       OLED_Cde(0xD9); //--set display clock divide ratio/oscillator frequency
        // A[3:0] : Phase 1 period of up to 15 DCLK clocks 0 is invalid entry(RESET=2h)
        // A[7:4] : Phase 2 period of up to 15 DCLKclocks 0 is invalid entry(RESET=2h )
       //OLED_Cde(0x1F); //  1F
       OLED_Cde(0x77); 
          //0xDA, (C.OLED_HEIGHT==64)?0x12:0x02,
       OLED_Cde(0xDA); //--set com pins hardware configuration
       OLED_Cde(0x20);  // was 0x20     32
       //        A[4]=0b, Sequential COM pin configuration
       //        A[4]=1b(RESET), Alternative COM pin configuration
       //        A[5]=0b(RESET), Disable COM Left/Right remap
       //        A[5]=1b, Enable COM Left/Right remap
       //OLED_Cde(0xE0);      // Read-Modify-Write start
       OLED_Cde(0xEE);      // Read-Modify-Write end.
       OLED_Cde(0x81); //--set contrast control register
       OLED_Cde(0x7F); // 0x00~0xff
       OLED_Cde(0x2E); // no scrolling
       OLED_Cde(0xDB); //--set VComH deselect level
       //   OLED_Cde(0x35); //--POR =35h
       OLED_Cde(0x40); // 20H => 0.77x Vcc (Reset value)
       OLED_Cde(0x8D); //--set DC-DC enable  Charge Pump Setting
       OLED_Cde(0x14); // 0x14 Enable Charge Pump
       OLED_Cde(0xAF); //--turn on oled panel
}



// ===================================================
//  extern file const char Fonte[]=         format 5x7
//===================================================