/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.****

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.4
        Device            :  PIC18F27K42
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/




#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "Fontes_for_OLED.h"
#include "OLED_SSD1306_I2C_Hardw_18Fx7K42_2021.h"

#define _XTAL_FREQ 64000000  
#define FOSC      64000000              // Fosc=64MHz
#define FCY       (FOSC/4)              // Fcy=16MHz
#define BR        19200                // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1)          // brgs=1

#define Delay_4sec() {__delay_ms(2000); __delay_ms(2000);}

#define ADCRES  3.6/4096.0   // ADC  per volt =3.6/4096 , vcc/adc , 2^12

i2c1_address_t Addr=0x3C;
adc_result_t pot_value;   
//uint16_t pot_value = 0;
uint16_t temp = 0;
uint16_t time_out=20;
unsigned char TEXTE[80];
unsigned char *txt;
char CRam1[80];
long l;
int i,j,k;
volatile char Buffer1[80];
volatile char Buffer2[80];
volatile int Index1,i1;
volatile char c1,c2;
volatile char Flag_Buffer1;

unsigned char Table[8];
char ADCstr[7];
char Tempstr[5];
float F0,F1;


/*
void __interrupt(high_priority) highIsr(void)
{

    //------UART1 ---------------------------------------
 if ( (PIR3bits.U1RXIF) && (PIE3bits.U1RXIE ==1) )     
 {
  unsigned char c1;
   // frame error
  while(U1ERRIRbits.FERIF==1)
  {
    c1= U1RXB;     
  }
  //overflow
  if( U1ERRIRbits.RXFOIF==1)
  {
    c1= U1RXB;  
    U1ERRIRbits.RXFOIF=0;
  }
  // echo
  c1=U1RXB;
  
 // renvoi echo
 //while (!PIR3bits.U1TXIF) { } ;
 // U1TXB = c1;
  if (c1==10) 
  { 
   c1='.';
  }
 else
 {        
    if (c1==13) 
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
    }
    else
    {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
    } 
  } 
}
// ---
}
*/


void CRLF1(void)
{
    while(PIR3bits.U1TXIF==0);
    U1TXB=13;
    while(PIR3bits.U1TXIF==0);
    U1TXB=10;
} 


 void Print (char * T1)
 {
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0) continue;
     U1TXB=*(T1);
    T1++;
   }
}
  
 
 
 void CPrint (const char * T1)
 {
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0) continue;
     U1TXB=*(T1);
    T1++;
   }
}

 
void RAZ_Buffer1(void)
{ 
    for (i1=0;i1<80;i1++) Buffer1[i1]=0;
    i1=0;
    Index1=0;
     Flag_Buffer1=0;
     U1FIFO=0;
   // PIE3bits.U1RXIE=1;
     
}


void RAZ_Buffer2(void)
{ int i=0;
    for (i=0;i<80;i++) Buffer2[i]=0;
}

// https://microchipdeveloper.com/xc8:console-printing
 void putch(unsigned char donnee)
 {
 while (!PIR3bits.U1TXIF)   continue;
    U1TXB=  donnee;                     // send one character
    PIR3bits.U1TXIF=0;
}







void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
  
  putch('A'); ;
  putch('B');
  putch('C');
  putch('D');
  putch('E');
  putch('F');
  CRLF1();

  // indispensable !
  INTERRUPT_GlobalInterruptEnable();


    txt=TEXTE;
    CRLF1();
    printf(" Projet MPLABX : _18F27K42_mini_OLED_20x10mm_SSD1306.X\r\n Compile le %s a %s UTC\r\n avec version XC8 :  %d\r\n", __DATE__, __TIME__, __XC8_VERSION);
    CPrint(" Usage de OLED_SSD1306_I2C_Hardw_18Fx7K42_2021.c  rev 02/01/20201 \r\n");
    CPrint(" Hardware : BASE 18F27K42 \r\n");
    CPrint(" Entree ANA sur RA1 \r\n");
    CPrint(" Sortie NCO1 10Khz sur RA3 \r\n");
    CPrint(" SQA50 synchro Analyser : Sortie sur RC5 \r\n");
    __delay_ms(2000);
     
    // just for testing purpose with SQA50 analyser
    /*
    CPrint(" TEST I2C1 Hardware write 2 bytes sur @0x3C \r\n");
    time_out=50;
    Addr=0x3C;
    IO_RC5_SetHigh(); // RA5
    Table[0]=0xAA; // commande
    Table[1]=0x55; // cmd
    I2C1_WriteNBytes(SSD1306_ADDR,Table, 2);  
     IO_RC5_SetLow();
    __delay_ms(1000);
   */
    RAZ_Buffer1();
    RAZ_Buffer2();
    
    CPrint(" Init mini-OLED SSD1306 20x10mm  I2C1 Hardware avec OLED_Init \r\n");
    CPrint(" 4 lignes de 128/6=21 chars avec fonte 5x8\r\n");
    IO_RC5_SetHigh();   // RA5     SQA_SetHigh(); 
    OLED_Init(); 
    IO_RC5_SetLow();    //SQA_SetLow() ;
    
    CPrint(" Clear OLED \r\n");
    OLED_Clear();
     __delay_ms(100); //"123456789012345678901")// gabarit !
    sprintf(Buffer2,     "Mini OLED SSD1306 I2C");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(0);   
    OLED_WriteString(Buffer2);
    
    sprintf(Buffer2,"123456789012345678901"); // 21cars en 6x8
 //   sprintf(Buffer2,"123456789012345678"); //18 cars  en 7x8
 //   sprintf(Buffer2,"1234567890123456"); // 16 cars en 8x8
    OLED_SelectPage(1); 
    OLED_WriteString(Buffer2);
    Print(Buffer2);  CRLF1();
     
    sprintf(Buffer2,"Ligne #03  Page #2   ");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(2);   
    OLED_WriteString(Buffer2);
    
    sprintf(Buffer2,"Ligne #04  Page #3   ");
    Print(Buffer2);  CRLF1();
    OLED_SelectPage(3);   
    OLED_WriteString(Buffer2);
     
     Delay_4sec();
  
     CPrint(" Clear OLED \r\n");
    OLED_Clear();
    CPrint(" Affiche lettres A B C ...Q \r\n");
    CPrint("  Write_Char_At(X en pixel (0 a 127), ligne Y (0 a 3),code ascii char)\r\n");
     Write_Char_At(0,0,'A');
     Write_Char_At(8,1,'B');
     Write_Char_At(16,2,'C');
     Write_Char_At(24,3,'D');
     Write_Char_At(32,3,'E');
     Write_Char_At(40,2,'F');
     Write_Char_At(48,1,'G');
     Write_Char_At(56,0,'H');
     Write_Char_At(56,1,'I');
     Write_Char_At(64,2,'J');
     Write_Char_At(72,3,'K');
     Write_Char_At(80,3,'L');
     Write_Char_At(88,3,'M');
     Write_Char_At(96,2,'N');
     Write_Char_At(104,1,'O');
     Write_Char_At(112,0,'P');
     Write_Char_At(120,1,'Q');
     Delay_4sec();
    
     
     
    CPrint(" Clear OLED \r\n");
    OLED_Clear();
     __delay_ms(1000);
  
    // OLED_ClearLine(3);   
    // OLED_ClearLine(2);
    // OLED_ClearLine(1);
    // OLED_ClearLine(0);
          //             "123456789012345678901"
    sprintf(Buffer2,     "MPLAB X XC8 02-01-21 ");
    OLED_SelectPage(0); 
    OLED_WriteString(Buffer2);
    
    sprintf(Buffer2,  "Mini-OLED SSD13061"); // 21cars en 6x8
 //   sprintf(Buffer2,"123456789012345678"); //18 cars  en 7x8
 //   sprintf(Buffer2,"1234567890123456"); // 16 cars en 8x8
    OLED_SelectPage(1); 
    OLED_WriteString(Buffer2);
    Print(Buffer2);
    CRLF1();
     __delay_ms(1000);   
     
    sprintf(Buffer2,  "OLED x=10 y=2"); 
    Print(Buffer2); CRLF1();
    *(Buffer2+4)=0; // OLED seulement
    OLED_ShowStr(10,2,Buffer2,1);
     __delay_ms(1000); 
     
    sprintf(Buffer2,  "OLED x=60 y=3"); 
    Print(Buffer2); CRLF1();
    *(Buffer2+4)=0;
    OLED_ShowStr(60,3,Buffer2,2);
    Delay_4sec();

    OLED_Clear();
     __delay_ms(1000);    
    j=0;
    
    OLED_SelectPage(0);
    Buffer2[0]=0;// "123456789012345678901")// gabarit !
    sprintf(Buffer2, "..ZIG-ZAG en Boucle.."); 
    OLED_WriteString(Buffer2);
    Print(Buffer2); CRLF1();
    
   while (1)
    {  
      
    OLED_ClearLine(1);
    sprintf(Buffer2, "Ball");
    OLED_ShowStr(j,1,Buffer2,2);
      
    OLED_SelectPage(2);
    Buffer2[0]=0; //"123456789012345678901")// gabarit !
    sprintf(Buffer2,"MCU 18F27K42 I2C HW  ");
    OLED_WriteString(Buffer2);
    Print(Buffer2);
    Print(9);
        
    //4em ligne (page 3))
    pot_value = ADCC_GetSingleConversion(channel_ANA1);
    F0 = (float) pot_value * ADCRES ;//* 10000;
    OLED_SelectPage(3);
     __delay_ms(20);
                  //"123456789012345678901")// gabarit !
    Buffer2[0]=0; //"EA1=4095 soit 3.600V")// gabarit !
    sprintf(Buffer2,"EA1=%4u soit %2.3fV ",pot_value,F0);
    OLED_WriteString(Buffer2);
    Print(Buffer2);
    CRLF1();
   
    IO_RA4_Toggle();
   //_delay_ms(50);
    j++;   
    if (j>95) j=0;
      //  suivre gestion interrupt UART1
        // RAZ_Buffer1();
    }
}

/*
 End of File
*/
/*
 Memory Summary:
    Program space        used  7134h ( 28980) of 20000h bytes   ( 22.1%)
    Data space           used   46Fh (  1135) of  2000h bytes   ( 13.9%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)
    Data stack space     used     0h (     0) of  1B68h bytes   (  0.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/_18F27K42_mini_OLED_20x10mm_SSD1306_2021.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/_18F27K42_mini_OLED_20x10mm_SSD1306_2021.X'

BUILD SUCCESSFUL (total time: 10s)
Loading code from C:/MPLABX_Projects/_18F27K42_mini_OLED_20x10mm_SSD1306_2021.X/dist/default/production/_18F27K42_mini_OLED_20x10mm_SSD1306_2021.X.production.hex...
Loading completed
Connecting to programmer...
Programming target...
Programming completed
Running target... 
 * 
 * Connecting to MPLAB PICkit 4...

Currently loaded versions:
Application version............00.05.41
Boot version...................01.00.00
Script version.................00.03.33
Script build number............0540a22e50
Target voltage detected
Target device PIC18F27K42 found.
Device Revision Id  = 0xa0010000

Calculating memory ranges for operation...

Erasing...

The following memory area(s) will be programmed:
program memory: start address = 0x0, end address = 0x7f
program memory: start address = 0xed80, end address = 0x15eff
configuration memory
User Id Memory

Programming/Verify complet
 * 
 * 
 * Ligne #04  Page #3   
ABCDEF

 Projet MPLABX : _18F27K42_mini_OLED_20x10mm_SSD1306.X
 Compile le Jan 02 2021 a 15:53:21 UTC
 avec version XC8 :  2100
 Usage de OLED_SSD1306_I2C_Hardw_18Fx7K42_2021.c  rev 02/01/20201 
 Hardware : BASE 18F27K42 
 Entree ANA sur RA1 
 Sortie NCO1 10Khz sur RA3 
 SQA50 synchro Analyser : Sortie sur RC5 
 Init mini-OLED SSD1306 20x10mm  I2C1 Hardware avec OLED_Init 
 4 lignes de 128/6=21 chars avec fonte 5x8
 Clear OLED 
Mini OLED SSD1306 I2C
123456789012345678901
Ligne #03  Page #2   
Ligne #04  Page #3   
 Clear OLED 
 Affiche lettres A B C ...Q 
  Write_Char_At(X en pixel (0 a 127), ligne Y (0 a 3),code ascii char)
 Clear OLED 
Mini-OLED SSD13061
OLED x=10 y=2
OLED x=60 y=3
..ZIG-ZAG en Boucle..
MCU 18F27K42 I2C HW  H?EA1=2045 soit 1.797V 
MCU 18F27K42 I2C HW  H?EA1=2041 soit 1.794V 
MCU 18F27K42 I2C HW  H?EA1=2039 soit 1.792V 
MCU 18F27K42 I2C HW  H?EA1=2040 soit 1.793V 
MCU 18F27K42 I2C HW  H?EA1=2043 soit 1.796V 
MCU 18F27K42 I2C HW  H?EA1=2040 soit 1.793V 
MCU 18F27K42 I2C HW  H?EA1=2037 soit 1.790V 
MCU 18F27K42 I2C HW  H?EA1=2040 soit 1.793V 
MCU 18F27K42 I2C HW  H?EA1=2040 soit 1.793V 
MCU 18F27K42 I2C HW  H?EA1=2040 soit 1.793V 




*/